#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*
 * HEADER : fintf.fc    - Vers 3.6.001  - Sep 1993 -  L. Fini, M. Pucillo
 *                      - Vers 3.6.000  - Oct 1991 -  L. Fini, M. Pucillo
 *
 *
 * AGL FORTRAN to C interface -- 	Generic version to be filtered 
 *					in order to generate the machine 
 *					dependent code.
 *
 *
 * This module is a C layer needed to interface the AGL FORTRAN interface
 * Layer to the AGL standard C interface
 *
 * Entry points correspond one-to-one to standard C interface (except for
 * AGIDN routine which is directly implemented in FORTRAN in file agidn.for
 *
 * The two routines: AG_SCAN, AG_DMSG are available in the C interface only
 *
 * Modified: 910617. CG: Master Fortran to C file. 
 * Modified: 910825. CG: This code only compiled for Unix systems.
 * Modified: 920115. CG: For both VMS and UNIX.
 *
 * 090422	last modif
 *
 * ===============================
 *  AGL FORTRAN STANDARD INTERFACE
 *
 *
 *
 *
 *
 *  The following entry points define the AGL standard FORTRAN interface
 *
 *
 * I   - Status operations
 *
 * AGCLS
 *
 * AGCDEF ( XCLIP0, XCLIP1, YCLIP0, YCLIP1 ) 
 * 
 * AGSSET (STRING)
 *
 * AGVDEF ( DEVICE, IDENT, XA, XB, YA, YB, XLIM, YLIM )
 *
 * AGVKIL
 * 
 * AGVSEL ( IDENT )
 *
 * AGWDEF ( X0, X1, Y0, Y1 )
 *
 * 
 * II  - Graphic primitives
 *
 * AGGPLG ( X, Y, N )
 *
 * AGGPLL ( X, Y, N )
 * 
 * AGGPLM ( X, Y, N, MARK )
 *
 * AGGINT ( X, Y, N )
 *
 * AGGTXT ( XT, YT, STRING, CENTRE )
 *
 * AGVERS
 * 
 *
 * III - Get information
 *
 * AGIGET (STRING,IVECT)
 * 
 * AGRGET (STRING,RVECT)
 * 
 * AGTGET ( STRING, XL, YL )
 * 
 * AGVLOC ( X, Y, CHAR, PIXVAL )
 *
 * AGVLOS ( X, Y, MAXLEN, STR, PIXVAL )
 *
 *
 * IV  - Metafile manipulation
 *
 * AGMCLS
 * 
 * AGMOPN ( NAME )
 * 
 * AGMRDW ( MFILE )
 *
 * AGMRES
 * 
 * AGMSUS
 *
 *
 * V   - Miscellaneous
 *
 * AGESC ( CMD, CMDLEN )
 *
 * AGDRIV 
 *
 * AGIDN ( IDENT )
 * 
 * AGMAGN ( XFACT, YFACT, X, Y, N )
 *
 * AGTROT ( X, Y, N )
 *
 * AGTSET ( XFACT, YFACT, ANGLE, ITEM )
 *
 * AGVN2U ( XN, YN, XV, YV )
 * 
 * AGVU2N ( XU, YU, XN, YN )
 *
 * AGVUPD 
 *
 * VI   - High level routines
 *
 * AGAXES ( X0, X1, Y0, Y1, CMDSTR )
 *
 * AGAXIS ( TYPE, DATA, LSPACE, FORM, LABEL )
 *
 * AGORAX ( TYPE, ENDS, DATA, FORM, LABEL )
 *
 * AGHIST ( X, Y, N, MODE, JOIN )
 *
 * AGNLIN ( X0, X1, Y0, Y1, CMDSTR )
 *
 */


#include <stdio.h>
#include <proto_agl.h>

#include <stdlib.h>
#include <string.h>

#ifndef MIN
#define MIN(x,y)        ((x) <= (y) ? (x):(y) )    /* Minimum */
#endif /* MIN */

int   mm;
char *ptr1, *ptr2;
extern char *loc_pntr(int jdx,int* loclen);
extern char *strp_pntr(int jdx);

/*

*/

/* I   - Status operations */

#define AGCDEF	agcdef_
ROUTINE AGCDEF (x1,x2,y1,y2)
float *x1;
float *x2;
float *y1;
float *y2; 

{ 
AG_CDEF ( *x1, *x2, *y1, *y2 ); 
return 0;
}

#define AGCLS	agcls_
ROUTINE AGCLS () { AG_CLS (); return 0;}

/*==========================================================================*/

/*** stat =  AG_SSET(command) ***/

#define AGL1	agl1_
ROUTINE AGL1 (status)
int  *status;	/* dummy argument - not used */

{ 
ptr1 = strp_pntr(1);            /* get stripped string of "command" */

AG_SSET (ptr1);
return 0;
}

/*==========================================================================*/

/*** stat =  AGVDEF ( device, xa,xb,ya,yb,xlim,ylim) ***/

#define AGL2	agl2_
ROUTINE AGL2 ( xa,xb,ya,yb,xlim,ylim)
float *xa;
float *xb;
float *ya;
float *yb;
float *xlim;
float *ylim;

{
ptr1 = strp_pntr(1);            /* get stripped string of "device" */

(void) AG_VDEF(ptr1, *xa, *xb, *ya, *yb, *xlim, *ylim);
return 0;
}

#define AGVKIL	agvkil_
ROUTINE AGVKIL () { AG_VKIL (); return 0;}

#define AGVSEL	agvsel_
ROUTINE AGVSEL (id)
int *id;        

{ 
AG_VSEL ( *id ); 
return 0;
}

#define AGWDEF	agwdef_
ROUTINE AGWDEF (x1,x2,y1,y2)
float *x1;
float *x2;
float *y1;
float *y2; 

{ 
AG_WDEF ( *x1, *x2, *y1, *y2 ); 
return 0;
}

/* II  - Graphic primitives */

#define AGGPLG	aggplg_
ROUTINE AGGPLG (xv,yv,np)
float xv[];
float yv[];
int *np;

{ 
AG_GPLG ( xv, yv, *np ); 
return 0;
}

#define AGGPLL	aggpll_
ROUTINE AGGPLL (xv,yv,np)
float xv[];
float yv[];
int *np;

{ 
AG_GPLL ( xv, yv, *np ); 
return 0;
}

#define AGGPLM	aggplm_
ROUTINE AGGPLM (xv,yv,np,mark)
float xv[];
float yv[];
int  *np;
int  *mark;

{ 
AG_GPLM ( xv, yv, *np, *mark ); 
return 0;
}

#define AGGINT	aggint_
ROUTINE AGGINT (xv,yv,np)
float xv[];
float yv[];
int *np;

{ 
AG_GINT ( xv, yv, *np ); 
return 0;
}

/*==========================================================================*/

/*** void AGGTXT (xc,yc,str,cntr) ***/

#define AGL3	agl3_
ROUTINE AGL3 (xc,yc,cntr)
float *xc;
float *yc;
int  *cntr;

{ 
ptr1 = strp_pntr(1);            /* get stripped string of "str" */

AG_GTXT ( *xc, *yc, ptr1, *cntr ); 
return 0;
}

#define AGVERS	agvers_
ROUTINE AGVERS () { AG_VERS (); return 0;}

/*==========================================================================*/

/*** void AGGERR (code,mesg) ***/

#define AGL4	agl4_
ROUTINE AGL4 (code)
int *code;

{ 
ptr1 = strp_pntr(1);            /* get stripped string of "mesg" */

AG_GERR( *code,ptr1);
return 0;
}

#define AGISET	agiset_
ROUTINE AGISET (ints,numb) 
int ints[],numb;  

{ 
AG_ISET (numb,ints); 
return 0;
}

#define AGRSET	agrset_
ROUTINE AGRSET (floats,numb) 
float floats[]; int numb; 

{ 
AG_RSET(numb,floats); 
return 0;
}

/* III - Get information */


/*==========================================================================*/

/*** int AG_IGET (item,ival) ***/

#define AGL5	agl5_
ROUTINE AGL5 (ival) 
int *ival;

{
int  n;

ptr1 = strp_pntr(1);            /* get stripped string of "item" */

n = AG_IGET ( ptr1, ival ); 
return 0;
}

/*==========================================================================*/

/*** int AG_RGET (item,fval) ***/

#define AGL6	agl6_
ROUTINE AGL6 (fval) 
float *fval;

{ 
int  n;

ptr1 = strp_pntr(1);            /* get stripped string of "item" */

n = AG_RGET (ptr1, fval ); 
return 0;
}


/*==========================================================================*/

/*** void AG_TGET (item,xd,yd) ***/

#define AGL7	agl7_
ROUTINE AGL7 (xd,yd)
float  *xd;
float  *yd;

{
ptr1 = strp_pntr(1);            /* get stripped string of "item" */

AG_TGET (ptr1, xd, yd ); 
return 0;
}

#define AGVLOC	agvloc_
ROUTINE AGVLOC (xv,yv,key,pixval)
float *xv;
float *yv;
int *key;
int *pixval;

{
AG_VLOC ( xv, yv, key, pixval ); 
return 0;
}


/*==========================================================================*/

/*** void AG_VLOS (xv,yv,maxlen,chstrg,pixval) ***/

#define AGL8	agl8_
ROUTINE AGL8 (xv,yv,maxlen,pixval)
float *xv;
float *yv;
int  *maxlen;
int  *pixval;

{
int  nn;


ptr1 = loc_pntr(1,&mm);            /* get location of "chstrg" */

AG_VLOS ( xv, yv, (mm-1), ptr1, pixval ); 

nn = (int) strlen(ptr1);
if (nn < mm) *(ptr1+mm) = ' ';
return 0;
}

/* IV  - Metafile manipulation */

#define AGMCLS	agmcls_
ROUTINE AGMCLS () { AG_MCLS (); return 0;}


/*==========================================================================*/

/*** void AG_MOPN (fname) ***/

#define AGL9	agl9_
ROUTINE AGL9 ( status )
int  *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "fname" */

AG_MOPN (ptr1);
return 0;
}

/*==========================================================================*/

/*** void AG_MRDW (metafile) ***/

#define AGL10	agl10_
ROUTINE AGL10 ( status )
int  *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "metafile" */

AG_MRDW (ptr1);
return 0;
}

#define AGMRES	agmres_
ROUTINE AGMRES () { AG_MRES (); return 0;}

#define AGMSUS	agmsus_
ROUTINE AGMSUS () { AG_MSUS (); return 0;}

/* V  - Miscellaneus */


/*==========================================================================*/

/*** void AG_ESC (cmd,cmdlen) ***/

#define AGL11	agl11_
ROUTINE AGL11 (cmdlen)
int *cmdlen;

{
ptr1 = strp_pntr(1);            /* get stripped string of "cmd" */

AG_ESC ( ptr1, *cmdlen ); 
return 0;
}

#define AGDRIV	agdriv_
ROUTINE AGDRIV () { AG_DRIV (); return 0;}

#define AGMAGN	agmagn_
ROUTINE AGMAGN (xfact,yfact,xv,yv,np)
float *xfact;
float *yfact;
float xv[];
float yv[];
int *np;

{
AG_MAGN( *xfact, *yfact, xv, yv, *np ); 
return 0;
}

#define AGTROT	agtrot_
ROUTINE AGTROT (xv,yv,np)
float xv[];
float yv[];
int *np;

{
AG_TROT ( xv, yv, *np ); 
return 0;
}

#define AGTSET	agtset_
ROUTINE AGTSET (xoff,yoff,angle,item)
float *xoff;
float *yoff;
float *angle;
int   *item;

{
AG_TSET ( *xoff, *yoff, *angle, *item ); 
return 0;
}

#define AGVN2U	agvn2u_
ROUTINE AGVN2U (xn,yn,xu,yu)
float *xn;
float *yn;
float *xu;
float *yu;

{
AG_VN2U ( *xn, *yn, xu, yu ); 
return 0;
}

#define AGVU2N	agvu2n_
ROUTINE AGVU2N (xu,yu,xn,yn)
float *xu;
float *yu;
float *xn;
float *yn;

{
AG_VU2N ( *xu, *yu, xn, yn ); 
return 0;
}

#define AGVUPD	agvupd_
ROUTINE AGVUPD () { AG_VUPD (); return 0;}

/* VI - High level routines */


/*==========================================================================*/

/*** void AG_AXES (x1,x2,y1,y2,string) ***/

#define AGL12	agl12_
ROUTINE AGL12 (x1,x2,y1,y2)
float *x1;
float *x2;
float *y1;
float *y2; 
 
{ 
ptr1 = strp_pntr(1);            /* get stripped string of "string" */

AG_AXES ( *x1, *x2, *y1, *y2,ptr1);
return 0;
}

/*==========================================================================*/

/*** void AG_AXIS (type, data, lspace, form, label) ***/

#define AGL13	agl13_
ROUTINE AGL13 (type, data, lspace)
int *type;
float *data;
float *lspace;
 
{ 
ptr1 = strp_pntr(1);            /* get stripped string of "form" */
ptr2 = strp_pntr(2);            /* get stripped string of "label" */

AG_AXIS( *type, data, *lspace, ptr1, ptr2);
return 0;
}

/*==========================================================================*/

/*** void AG_ORAX ( type, ends, data, form, label ) ***/

#define AGL14	agl14_
ROUTINE AGL14 (type, ends, data )
int *type;
float *ends;
float *data;

{ 
ptr1 = strp_pntr(1);            /* get stripped string of "form" */
ptr2 = strp_pntr(2);            /* get stripped string of "label" */

AG_ORAX( *type, ends, data, ptr1, ptr2);
return 0;
}

#define AGHIST	aghist_
ROUTINE AGHIST (xv,yv,np,mode,join)
float *xv;
float *yv; 
int *np;
int *mode;
int *join;

{ 
AG_HIST ( xv, yv, *np, *mode, *join ); 
return 0;
}


/*==========================================================================*/

/*** void AG_NLIN(x1,x2,y1,y2,string) ***/

#define AGL15	agl15_
ROUTINE AGL15 (x1,x2,y1,y2)
float *x1;
float *x2;
float *y1;
float *y2; 
 
{ 
ptr1 = strp_pntr(1);            /* get stripped string of "string" */

AG_NLIN ( *x1, *x2, *y1, *y2,ptr1);
return 0;
}


/*==========================================================================*/

/*** void AG_FILL(x,y,n,space,angle,sset) ***/

#define AGL16	agl16_
ROUTINE AGL16(x,y,n,space,angle)
float *x;
float *y;
int   *n;
float *space;
float *angle;
 
{
ptr1 = strp_pntr(1);            /* get stripped string of "sset" */

AG_FILL( x, y, *n, *space, *angle, ptr1);
return 0;
}


