#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  genftoc.fc  +++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module genftoc.fc
.COMMENTS
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       tools
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 880414:  created 
.VERSION  [3.00] 901213:  Master file. CG.
.VERSION  [3.10] 920507:  Extracted from genftoc.fc, KB

 090611		last modif
-----------------------------------------------------------------------------*/

#include <midas_def.h>

#include <stdlib.h>

int   mm;

char *ptr1, *ptr2, *ptr3, *ptr4;
char *loc_pntr();
char *strp_pntr();

/*

*/

/*==========================================================================*/

/*** actval = CGN_CNVT(text,type,maxval,ibuf,rbuf,dbuf) ***/

#define STGN1	stgn1_
ROUTINE STGN1(type,maxval,ibuf,rbuf,dbuf,actval)
int  *type;	/* IN: = 1, for integer; = 2, for real; = 4, doubl pre*/
int  *maxval;	/* IN: maximal no. of output values */
int  *ibuf;	/* OUT: integer output buffer */
float   *rbuf;	/* OUT: real output buffer */
double  *dbuf;	/* OUT: double precision output buffer */
int  *actval;

{
ptr1 = strp_pntr(1);            /* get stripped string of "text" */

*actval = CGN_CNVT(ptr1,*type,*maxval,ibuf,rbuf,dbuf);

return 0;
}

/*==========================================================================*/

/*** stat = CGN_IBUILD(simno,name,datform,sizze,imno,cloned) ***/

#define STGN2	stgn2_
ROUTINE STGN2(simno,datform,sizze,imno,cloned,status)
int  *simno;     /* IN: id of source image */
int  *datform;   /* IN: format for new image, e.g. D_R4_FORMAT */
int  *sizze;     /* IN: no. of pixel of new image */
int *imno;       /* OUT: id of new image */
int *cloned;     /* OUT: cloned_flag, 1 = yes; 0 = no descr cloning done */
int *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "name" */

*status = CGN_IBUILD(*simno,ptr1,*datform,*sizze,imno,cloned);

return 0;
}

/*==========================================================================*/

/*** stat = CGN_NUMBER(text) ***/

#define STGN3	stgn3_
ROUTINE STGN3(status)
int *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "text" */

*status = CGN_NUMBER(ptr1);

return 0;
}

/*==========================================================================*/

/*** void CGN_LOGNAM(infile,outfile,maxout) ***/

#define STGN4	stgn4_
ROUTINE STGN4(maxout)
int	*maxout;	/* IN: max length of outfile            */

{
int  n, k;

ptr1 = strp_pntr(1);            /* get stripped string of "infile" */
ptr2 = loc_pntr(1,&mm);             /* get location of "outfile" */

CGN_LOGNAM(ptr1,ptr2,*maxout);

n = (int) strlen(ptr2);
if ((n > 0) && (n < mm))
   {
   for (k=n; k<mm; k++) *(ptr2+k) = ' ';
   }


return 0;
}


/*==========================================================================*/

/*** stat = OSY_ASCTIM(time) ***/

#define STGN5	stgn5_
ROUTINE STGN5(status)
int *status;

{
int  n;


ptr1 = loc_pntr(1,&mm);            /* get location of "time" */

*status = OSY_ASCTIM(ptr1);

n = (int) strlen(ptr1);
if ((n > 0) && (n < mm)) *(ptr1+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = CGN_EQUAL(afile,bfile) ***/

#define STGN6	stgn6_
ROUTINE STGN6(status)
int *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "afile" */
ptr2 = strp_pntr(2);            /* get stripped string of "bfile" */

mm = CGN_EQUAL(ptr1,ptr2);
*status = 1 - mm;	/* returned status = 0 if equal and 1 if not ...  */

return 0;
}

/*==========================================================================*/

/*** C-interface for GENLEN(str,status) ***/

#define STGN7	stgn7_
ROUTINE STGN7(status)
int *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "str" */

*status = (int) strlen(ptr1);

return 0;
}

/*==========================================================================*/

/*** indx = issub(nfile) ***/

#define STGN8	stgn8_
ROUTINE STGN8(indx)
int *indx;	/* OUT: index of substring specs, else = 0 */

{
ptr1 = strp_pntr(1);            /* get stripped string of "infile" */

mm = issub(ptr1);
if (mm > 0)
   *indx = mm + 1;		/* in C we start from 0 ...  */
else
   *indx = 0;

return 0;
}

/*==========================================================================*/

/*** stat = CGN_DSCUPD(*inno,*outno,history) ***/

#define STGN9	stgn9_
ROUTINE STGN9(inno,outno,status)
int    *inno;		/* IN: source file no. */
int    *outno;		/* IN: dest. file no. */
int *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "history" */

*status = CGN_DSCUPD(*inno,*outno,ptr1);

return 0;
}



