#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  stc.fc +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module stc.fc
.COMMENTS
Module contains layer between the catalog related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 880919:  created
.VERSION  [1.20] 881010:  add SZCSHO
.VERSION  [1.30] 890119:  updated
.VERSION  [1.40] 900219:  update parameters of SZCSHO
.VERSION  [3.00] 901213:  Master file. CG.

 090611		last modif
-----------------------------------------------------------------------------*/


#include <midas_def.h>

#include <stdlib.h>
#include <stdio.h>

int  mm;

char *ptr1, *ptr2, *ptr3;
char *strp_pntr();
char *loc_pntr();

/*

*/

/*==========================================================================*/

/*** stat = SCCGET(catfile,flag,name,ident,no) ***/

#define STC1	stc1_
ROUTINE STC1(flag,no,status)
int	*flag;		/* IN: flag */
int	*no;		/* IN/OUT: current record no.  */
int	*status;	/* OUT: return status */

{
int  n, m1, m2;


ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */
ptr2 = loc_pntr(1,&m1);		/* get location of "name" */
ptr3 = loc_pntr(2,&m2);		/* get location of "ident" */

*status = SCCGET(ptr1,*flag,ptr2,ptr3,no);


/* replace '\0' by ' ' in the end */

n = (int) strlen(ptr2);
if ((n > 0) && (n < m1))  *(ptr2+n) = ' ';

n = (int) strlen(ptr3); 
if ((n > 0) && (n < m2)) *(ptr3+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = SCCADD(catfile,name,ident) ***/

#define STC2	stc2_
ROUTINE STC2(status)
int	*status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */
ptr2 = strp_pntr(2);		/* get stripped string of "name" */
ptr3 = strp_pntr(3);		/* get stripped string of "ident" */

*status = SCCADD(ptr1,ptr2,ptr3);

return 0;
}

/*==========================================================================*/

/*** stat = SCCSUB(catfile,name) ***/

#define STC3	stc3_
ROUTINE STC3(status)
int	*status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */
ptr2 = strp_pntr(2);		/* get stripped string of "name" */

*status = SCCSUB(ptr1,ptr2);

return 0;
}

/*==========================================================================*/

/*** stat = SCCCRE(catfile,type,flag) ***/

#define STC4	stc4_
ROUTINE STC4(type,flag,status)
int  *type;          /* IN: type of files to use, same as in SCFCRE  */
int  *flag;          /* IN: = 1, if file 'dirfile.dat' exists */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */

*status = SCCCRE(ptr1,*type,*flag);

return 0;
}


/*==========================================================================*/

/*** stat = SCCLIS(catfile,intval) ***/

#define STC5	stc5_
ROUTINE STC5(intval,status)
int  *intval;         /* IN: listing interval [low,hi]  */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */

*status = SCCLIS(ptr1,intval);

return 0;
}


/*==========================================================================*/

/*** stat = SCCSHO(catfile,totent,lastent) ***/

#define STC6	stc6_
ROUTINE STC6(totent,lastent,status)
int  *totent;        /* OUT: no. of entries */
int  *lastent;       /* OUT: last entry no. */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */

*status = SCCSHO(ptr1,totent,lastent);

return 0;
}

/*==========================================================================*/

/*** stat = SCCFND(catfile,frmno,name) ***/

#define STC7	stc7_
ROUTINE STC7(frmno,status)
int   *frmno;         /* IN: entry no. in catalog   */
int  *status;

{
int  n;

ptr1 = strp_pntr(1);		/* get stripped string of "catfile" */
ptr2 = loc_pntr(1,&mm);             /* get location of "name" */

*status = SCCFND(ptr1,*frmno,ptr2);

n = (int) strlen(ptr2);
if ((n > 0) && (n < mm)) *(ptr2+n) = ' ';

return 0;
}
 

