#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  std.fc +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module std.fc
.COMMENTS
 Module contains layer between the descriptor related FORTRAN STxxxx interfaces
 and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C

 090611		last modif
-----------------------------------------------------------------------------*/

#include <midas_def.h>
	
#include <stdlib.h>

static int  dunit = 0, dnull = -1;
int   mm;

char *ptr1, *ptr2;
char *loc_pntr();
char *strp_pntr();


/*

*/

/*==========================================================================*/

/*** stat = SCDRDI(no,descr,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD1	std1_
ROUTINE STD1(no,felem,maxvals,actvals,values,status)
int  *no;            /* IN : no. of data frame */
int	*felem;		/* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
int  *values;        /* OUT: buffer for data values */
int  *status;

{	
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */

*status = SCDRDI(*no,ptr1,*felem,*maxvals,actvals,values,&dunit,&dnull);

return 0;
}
 
/*==========================================================================*/

/*** stat = SCDRDL(no,descr,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD2	std2_
ROUTINE STD2(no,felem,maxvals,actvals,values,status)
int  *no;            /* IN : no. of data frame */
int  *felem;         /* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
int  *values;        /* OUT: buffer for data values */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */

*status = SCDRDL(*no,ptr1,*felem,*maxvals,actvals,values,&dunit,&dnull);

return 0;
}

/*==========================================================================*/

/*** stat = SCDRDR(no,descr,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD3	std3_
ROUTINE STD3(no,felem,maxvals,actvals,values,status)
int  *no;            /* IN : no. of data frame */
int  *felem;         /* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
float  *values;      /* OUT: buffer for data values */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */

*status = SCDRDR(*no,ptr1,*felem,*maxvals,actvals,values,&dunit,&dnull);

return 0;
}


/*==========================================================================*/

/*** stat = SCDRDD(no,descr,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD4	std4_
ROUTINE STD4(no,felem,maxvals,actvals,values,status)
int  *no;            /* IN : no. of data frame */
int  *felem;         /* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
double  *values;        /* OUT: buffer for data values */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */

*status = SCDRDD(*no,ptr1,*felem,*maxvals,actvals,values,&dunit,&dnull);

return 0;
}


/*==========================================================================*/

/*** stat = SCDRDS(no,descr,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD4a	std4a_
ROUTINE STD4a(no,felem,maxvals,actvals,values,status)
int  *no;            /* IN : no. of data frame */
int  *felem;         /* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
size_t  *values;        /* OUT: buffer for data values */
int  *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */

*status = SCDRDS(*no,ptr1,*felem,*maxvals,actvals,values,&dunit,&dnull);

return 0;
}


/*==========================================================================*/

/*** stat = SCDRDC(no,descr,noelm,felem,maxvals,actvals,values,dunit,dnull) ***/

#define STD5	std5_
ROUTINE STD5(no,noelm,felem,maxvals,actvals,status)
int  *no;        /* IN : no. of data frame */
int  *noelm;     /* IN : no. of data frame */
int  *felem;     /* IN : first data item to be read */
int  *maxvals;   /* IN : max. vals to read */
int  *actvals;   /* OUT: actual no. of elements returned */
int  *status;

{
int  n;

ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
ptr2 = loc_pntr(1,&mm);             /* get location of "values" */

n = *noelm;
*status = SCDRDC(*no,ptr1,n,*felem,*maxvals,actvals,ptr2,&dunit,&dnull);

n *= (*actvals);
if ((n > 0) && (n < mm)) *(ptr2+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = SCDRDH(no,descr,felem,maxvals,actvals,values,total) ***/

#define STD6	std6_
ROUTINE STD6(no,felem,maxvals,actvals,total,status)
int  *no;            /* IN : no. of data frame */
int  *felem;         /* IN : first data item to be read */
int  *maxvals;       /* IN : max. vals to read */
int  *actvals;       /* OUT: actual no. of elements returned */
int  *total;         /* OUT : total size of help text */
int  *status;

{
int  n;
  

ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
ptr2 = loc_pntr(1,&mm);             /* get location of "values" */

*status = SCDRDH(*no,ptr1,*felem,*maxvals,actvals,ptr2,total);

n = *actvals;
if ((n > 0) && (n < mm)) *(ptr2+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = SCDFND(no,descr,type,noelem,bytelem) ***/

#define STD7	std7_
ROUTINE STD7(no,noelem,bytelem,status)
int  *no;            /* IN : no. of data frame */
int  *noelem;        /* OUT: no. of elements  */
int  *bytelem;       /* OUT: no. of bytes per element  */
int  *status;

{
int  n;


ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
ptr2 = loc_pntr(1,&mm);             /* get location of "type" */

*status = SCDFND(*no,ptr1,ptr2,noelem,bytelem);


n = (int) strlen(ptr2);
if ((n > 0) && (n < mm)) *(ptr2+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = SCDINF(no,npos,field,buf,numbuf) ***/

#define STD8	std8_
ROUTINE STD8(no,npos,field,numbuf,status)
int  *no;           /* IN : no. of data frame */
int  *npos;         /* IN: position of descr */
int  *field;        /* IN: specify info,1 = NAME, 2 = TYPE, 3 = SIZE */
int  *numbuf;       /* IN : return buffer for numerical data  */
int  *status;

{
int  n;

ptr1 = loc_pntr(1,&mm);             /* get location of "buf", available space */
 
n = *field; 
*status = SCDINF(*no,*npos,n,ptr1,(mm-1),numbuf);

if (n != 3)			/* treat char. result buffer */
   {
   n = (int) strlen(ptr1);
   if ((n > 0) && (n < mm)) *(ptr1+n) = ' ';
   }

return 0;
}

/*==========================================================================*/

/*** stat = SCDRDX(no,flag,descr,type,bytel,noel,hnc) ***/

#define STD9	std9_
ROUTINE STD9(no,flag,bytel,noel,hnc,status)
int *no;        /* IN: imno of data frame */
int *flag;      /* IN: action flag
                       = 0,  free space again
                       = 1,  read in complete descr. directory
                       = 2,  as 1 and also return total no. of descriptors
                       = 10, return descr. info of next descr. */
int *bytel;     /* OUT: no. of bytes per element */
int *noel;      /* OUT: no. of elements */
int *hnc;       /* OUT: no. of help text chars */
int  *status;

{
int  n, m1, m2;

ptr1 = loc_pntr(1,&m1);             /* get location of "name" */
ptr2 = loc_pntr(2,&m2);             /* get location of "ident" */

*status = SCDRDX(*no,*flag,ptr1,ptr2,bytel,noel,hnc);

n = (int) strlen(ptr1);
if ((n > 0) && (n < m1)) *(ptr1+n) = ' ';

n = (int) strlen(ptr2);
if ((n > 0) && (n < m1)) *(ptr2+n) = ' ';

return 0;
}

/*==========================================================================*/

/*** stat = SCDWRC(no,descr,noelm,values,felem,maxvals,dunit)  ***/

#define STD10	std10_
ROUTINE STD10(no,noelm,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
int *noelm;     /* IN: no. of chars (bytes) per data value */
int *felem;     /* IN : first data item to be read */
int *maxvals;	/* IN : max. vals to read */
int *status;
 
{	
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
ptr2 = loc_pntr(1,&mm);		/* get location of "values" */


*status = SCDWRC(*no,ptr1,*noelm,ptr2,*felem,*maxvals,&dunit);

return 0;
}

/*==========================================================================*/

/*** stat = SCDWRD(no,descr,values,felem,maxvals,dunit)  ***/

#define STD11	std11_
ROUTINE STD11(no,values,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
double *values; /* IN: data values */
int *felem;     /* IN : first data item to be read */
int *maxvals;	/* IN : max. vals to read */
int *status;
 
{	
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
 
*status = SCDWRD(*no,ptr1,values,*felem,*maxvals,&dunit);

return 0;
}

/*==========================================================================*/

/*** stat = SCDWRH(no,descr,values,felem,maxvals)  ***/

#define STD12	std12_
ROUTINE STD12(no,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
int *felem;     /* IN : first data item to be read */
int *maxvals;   /* IN : max. vals to read */
int *status;
 
{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
ptr2 = strp_pntr(2);		/* get stripped string of "values" */
 
*status = SCDWRH(*no,ptr1,ptr2,*felem,*maxvals);

return 0;
}

/*==========================================================================*/

/*** stat = SCDWRI(no,descr,values,felem,maxvals,dunit)  ***/

#define STD13	std13_
ROUTINE STD13(no,values,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
int *values;    /* IN: data values */
int *felem;     /* IN : first data item to be read */
int *maxvals;	/* IN : max. vals to read */
int *status;
 
{	
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
 
*status = SCDWRI(*no,ptr1,values,*felem,*maxvals,&dunit);

return 0;
}


/*==========================================================================*/

/*** stat = SCDWRL(no,descr,values,felem,maxvals,dunit)  ***/

#define STD14	std14_
ROUTINE STD14(no,values,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
int *values;    /* IN: data values */
int *felem;     /* IN : first data item to be read */
int *maxvals;   /* IN : max. vals to read */
int *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
 
*status = SCDWRL(*no,ptr1,values,*felem,*maxvals,&dunit);

return 0;
}

/*==========================================================================*/

/*** stat = SCDWRR(no,descr,values,felem,maxvals,dunit)  ***/

#define STD15	std15_
ROUTINE STD15(no,values,felem,maxvals,status)
int *no;        /* IN: imno of data frame */
float *values;  /* IN: data values */
int *felem;     /* IN : first data item to be read */
int *maxvals;   /* IN : max. vals to read */
int *status;

{
ptr1 = strp_pntr(1);		/* get stripped string of "descr" */
 
*status = SCDWRR(*no,ptr1,values,*felem,*maxvals,&dunit);

return 0;
}

#define STD16	std16_
ROUTINE STD16(no,status)
int  *no;            /* IN: no. of data frame */
int  *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "descr" */

*status = SCDDEL(*no,ptr1);

return 0;
}

#define STD17	std17_
ROUTINE STD17(from,to,mask,status)
int  *from;          /* IN: no. of source frame  */
int  *to;            /* IN: no. of destination frame  */
int  *mask;          /* IN: copy_mask  */
int  *status;

{
ptr1 = strp_pntr(1);            /* get stripped string of "descr" */

*status = SCDCOP(*from,*to,*mask,ptr1);

return 0;
}

#define STDRDZ	stdrdz_
ROUTINE STDRDZ(no,dirsize,direlem,status)
int  *no;            /* IN : no. of data frame */
int  *dirsize;       /* OUT : no. of chars used by descr-directory */
int  *direlem;       /* OUT : no. of descr. (incl directory) */
int  *status;

{
*status = SCDRDZ(*no,dirsize,direlem);

return 0;
}



