#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  sts.fc +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module sts.fc
.COMMENTS
Module contains layer between the system + text related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880411:  modified new version - the last one
.VERSION  [2.70] 900607:  add SCPSET interface...
.VERSION  [3.00] 901213:  Master file. CG.

 090611		last modif
-----------------------------------------------------------------------------*/

#include <midas_def.h>

#include <stdlib.h>


int   mm;

char *ptr1, *ptr2, *ptr3, *ptr4;
char *strp_pntr();

/*

*/

/*==========================================================================*/

#define STSEPI	stsepi_
ROUTINE STSEPI()

{
SCSEPI();

return 0;
}

#define STSPRO	stspro_
ROUTINE STSPRO(prog,lpro)
char *prog;		/* IN : name of calling program */
int  *lpro;		/* IN: length of string ... */

{	
SCSPRO(prog);

return 0;
}

#define STPSET	stpset_
ROUTINE STPSET(para,pval,status)
int *para;		/* IN: parameter no. given as a symbol */
int *pval;		/* IN: array with values (may be just one) */
int *status;

{	
*status = SCPSET(*para,pval);

return 0;
}

/*==========================================================================*/

/*** stat = SCSKIN(keyfile) ***/

#define STS1	sts1_
ROUTINE STS1(status)
int	*status;

{	
ptr1 = strp_pntr(1);            /* get stripped string of "keyfile" */

*status = SCSKIN(ptr1);

return 0;
}



