#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  tbd.fc +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module tbd.fc
.COMMENTS
Module contains layer between the frame related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880415:  modified new version - the last one
.VERSION  [2.70] 890119:  add SZCFRNM
.VERSION  [2.80] 900316:  fix problem with FNAME_LEN+2 ...
.VERSION  [3.00] 901213:  Master file. CG.

 090611		last modif
-----------------------------------------------------------------------------*/

#include <ftoc_log.h>           /* LOGICAL    */
#include <tblsys.h>
#include <tbldef.h>
#include <midas_def.h>

#include <stdlib.h>
 
static int one  = 1;
static int zero = 0;

int   n, mm;

char *ptr1, *ptr2, *ptr3, *ptr4;
char *loc_pntr();
char *strp_pntr();

/*

*/

/*==========================================================================*/

/*** stat = TCFGET(tid col,form,len,dtype) ***/

#define TBF1	tbf1_
ROUTINE TBF1(tid, col, len, dtype, status)
int *tid;     /* IN : table identifier */
int *col;     /* IN: Column       */
int  *len;    /* OUT: Bytes required for edited elemen */
int  *dtype;  /* OUT: data type */
int *status;  /* OUT: status return */

{
ptr1 = loc_pntr(1,&mm);            /* get location of "form" */

if (mm <= TBL_FORLEN)
   {
   char  myform[TBL_FORLEN+1];

   *status = TCFGET(*tid, *col, myform, len, dtype);
   n = (int) strlen(myform);
   if ((n > 0) && (n < (TBL_FORLEN+1)))
      {
      (void) strncpy (ptr1,myform,(size_t)n);
      }
   }

else
   {
   *status = TCFGET(*tid, *col, ptr1, len, dtype);
   n = (int) strlen(ptr1);
   if ((n > 0) && (n < mm)) 
      {
      *(ptr1+n) = ' ';
      }
   }

return 0;
}

/*==========================================================================*/

/*** stat = TCFPUT(tid, col, form) ***/

#define TBF2	tbf2_
ROUTINE TBF2(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* IN : column */
int *status;    /* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "form" */

*status = TCFPUT(*tid, *col, ptr1);

return 0;
}

/*==========================================================================*/

/*** stat = TCIGET(tid, cols, rows, nsort, acols, arows) ***/

#define TBIGET	tbiget_
ROUTINE TBIGET(tid, cols, rows, nsort, acols, arows, status)
int *tid;     /* IN : table identifier */
int*cols;     /* OUT: Number of Columns       */
int  *rows;   /* OUT: Number of Rows          */
int  *nsort;  /* OUT: Sorted Column Number    */
int  *acols;  /* OUT: Number of Alloc.Columns */
int  *arows;  /* OUT: Number of Alloc. Rows   */
int *status;  /* OUT: status return */

{
*status = TCIGET(*tid, cols, rows, nsort, acols, arows);

return 0;
}

/*==========================================================================*/

/*** stat = TCIPUT(tid, cols, rows) ***/

#define TBIPUT	tbiput_
ROUTINE TBIPUT(tid, cols, rows, status)
int *tid;       /* IN : table identifier */
int *cols;     /* IN : no. of  columns */
int *rows;     /* IN : no. of  rows */
int *status;    /* OUT: status return */

{
*status = TCIPUT(*tid, *cols, *rows);

return 0;
}

/*==========================================================================*/

/*** stat = TCKGET(tid, col) ***/

#define TBKGET	tbkget_
ROUTINE TBKGET(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* OUT : reference column */
int *status;    /* OUT: status return */

{
*status = TCKGET(*tid, col);

return 0;
}

/*==========================================================================*/

/*** stat = TCKPUT(tid, col) ***/

#define TBKPUT	tbkput_
ROUTINE TBKPUT(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* IN : reference column */
int *status;    /* OUT: status return */

{
*status = TCKPUT(*tid, *col);

return 0;
}

/*==========================================================================*/

/*** stat = TCLGET(tid, col, label) ***/

#define TBL1	tbl1_
ROUTINE TBL1(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* IN : column no. */
int *status;    /* OUT: status return */

{
ptr1 = loc_pntr(1,&mm);            /* get location of "label" */

if (mm <= TBL_LABLEN)
   {
   char  mylabel[TBL_LABLEN+1];

   *status = TCLGET(*tid,*col,mylabel);

   n = (int) strlen(mylabel);
   if ((n > 0) && (n < (TBL_LABLEN+1)))
      {
      (void) strncpy (ptr1,mylabel,(size_t)n);
      }
   }

else
   {
   *status = TCLGET(*tid, *col, ptr1);

   n = (int) strlen(ptr1);
   if ((n > 0) && (n < mm))
      {
      *(ptr1+n) = ' ';
      }
   }

return 0;
}


/*==========================================================================*/

/*** stat = TCLPUT(tid, col, label) ***/

#define TBL2	tbl2_
ROUTINE TBL2(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* IN : column no. */
int *status;    /* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "label" */

*status = TCLPUT(*tid, *col, ptr1);

return 0;
}

/*==========================================================================*/

/*** stat = TCLSER(tid, label, col) ***/

#define TBL3	tbl3_
ROUTINE TBL3(tid, col, status)
int *tid;       /* IN : table identifier */
int *col;     /* OUT : column no. */
int *status;    /* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "label" */

*status = TCLSER(*tid, ptr1, col);

return 0;
}

/*==========================================================================*/

/*** stat = TCSGET(tid, row, value) ***/

#define TBSGET	tbsget_
ROUTINE TBSGET(tid, row, value, status)
int *tid; 	/* IN : table identifier */
int *row;       /* IN : Row concerned    */
int *value;     /* OUT : Selection Flag   */
int *status;	/* OUT: status return */

{
*status = TCSGET(*tid, *row, value);

*value = (*value ? F77TRUE : F77FALSE);

return 0;
}

/*==========================================================================*/

/*** stat = TCSPUT(tid, row, value) ***/

#define TBSPUT	tbsput_
ROUTINE TBSPUT(tid, row, value, status)
int *tid; 	/* IN : table identifier */
int *row;       /* IN : Row concerned    */
int *value;     /* IN : Selection Flag   */
int *status;	/* OUT: status return */

{
*status = TCSPUT(*tid, *row, *value == F77FALSE ? &zero : &one);

return 0;
}

/*==========================================================================*/

/*** stat = TCSINI(tid) ***/

#define TBSINI	tbsini_
ROUTINE TBSINI(tid, status)
int *tid; 	/* IN : table identifier */
int *status;	/* OUT: status return */

{
*status = TCSINI(*tid);

return 0;
}

/*==========================================================================*/

/*** stat = TCUGET(tid,col,tunit) ***/

#define TBU1	tbu1_
ROUTINE TBU1(tid,col,status)
int *tid; 	/* IN : table identifier */
int *col;       /* IN: column number */
int *status;	/* OUT: status return */

{
ptr1 = loc_pntr(1,&mm);            /* get location of "tunit" */

if (mm <= TBL_UNILEN)
   {
   char  myunit[TBL_UNILEN+1];

   *status = TCUGET(*tid,*col,myunit);

   n = (int) strlen(myunit);
   if ((n > 0) && (n < (TBL_UNILEN+1)))
      {
      (void) strncpy (ptr1,myunit,(size_t)n);
      }
   }
 else
   {
   *status = TCUGET(*tid, *col, ptr1);

   n = (int) strlen(ptr1);
   if ((n > 0) && (n < mm)) 
      {
      *(ptr1+n) = ' ';
      }
   }

return 0;
}

/*==========================================================================*/

/*** stat = TCUPUT(tid,col,tunit) ***/

#define TBU2	tbu2_
ROUTINE TBU2(tid,col,status)
int *tid; 	/* IN : table identifier */
int *col;       /* IN: column number */
int *status;	/* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "tunit" */

*status = TCUPUT(*tid,*col,ptr1);

return 0;
}

/*==========================================================================*/

/*** stat = TCDGET(tid,store) ***/

#define TBDGET	tbdget_
ROUTINE TBDGET(tid,store,status)
int *tid;       /* IN : table identifier */
int *store;     /* OUT: physical format (0 for columnwise) */
int *status;    /* OUT: status return */

{
*status = TCDGET(*tid,store);

return 0;
}


