#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  tbt.fc +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module tbt.fc
.COMMENTS
Module contains layer between the frame related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880415:  modified new version - the last one
.VERSION  [2.70] 890119:  add SZCFRNM
.VERSION  [2.80] 900316:  fix problem with FNAME_LEN+2 ...
.VERSION  [3.00] 901213:  Master file. CG.

 090611		last modif
-----------------------------------------------------------------------------*/

#include <ftoc_log.h>           /* LOGICAL    */
#include <tbldef.h>
#include <midas_def.h>

#include <stdlib.h>
 


char *ptr1, *ptr2;
char *strp_pntr();

/*

*/

/*==========================================================================*/

/*** stat = TCTINI(name,storage,mode,allcols,allrows,tid) ***/

#define TBT1	tbt1_
ROUTINE TBT1(storage,mode,allcols,allrows,tid,status)
int *storage;  /* IN : 0 for Transposed        */
int *mode;     /* IN : Opening Mode            */
int *allcols;  /* IN : Columns to allocate     */
int *allrows;  /* IN : Rows to allocate        */
int *tid; 	/* OUT : table identifier */
int *status;	/* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "name" */

*status = TCTINI(ptr1,*storage,*mode,*allcols,*allrows,tid);

return 0;
}

/*==========================================================================*/

/*** stat = TCTOPN(name, mode,tid) ***/

#define TBT2	tbt2_
ROUTINE TBT2(mode, tid, status)
int *mode;      /* IN : Opening Mode */
int *tid;       /* OUT : table identifier */
int *status;    /* OUT: status return */

{
ptr1 = strp_pntr(1);            /* get stripped string of "name" */

*status = TCTOPN(ptr1,*mode,tid);

return 0;
}


/*==========================================================================*/

/*** stat = TCTCLO(tid) ***/

#define TBTCLO	tbtclo_
ROUTINE TBTCLO(tid, status)
int *tid;       /* IN : table identifier */
int *status;    /* OUT: status return */

{
*status = TCTCLO(*tid);

return 0;
}


