#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1993-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.IDENTifier     ptb.fc
.AUTHOR         Rein H. Warmels, ESO-IPG
.KEYWORDS       High level graphics interface, Graphics keywords
.LANGUAGE       C
.PURPOSE        Fortran to C interface for PCAXES and PCFRAMK
.COMMENTS       Module contains interfaces for  PCDATA, PCHIST, and PCTEXT 
.ENVIRONMENT    MIDAS FORTRAN and C standards
.VERSION        1.0 13-Oct-1993 RHW

 090611		last modif
-----------------------------------------------------------------------------*/

#include <proto_plt.h>


char *ptr1;
char *loc_pntr();
char *strp_pntr();

/*

*/

#define PTDATA	ptdata_
ROUTINE PTDATA(stype,ltype,binmod,x_data,y_data,y_off,nrdata)
int     *stype;	/* IN: symbol type only plotted if ltype equal zero */
int     *ltype;	/* IN: line  type only plotted if ltype equal zero */
int    *binmod;	/* IN: bin mode OFF = 1; ON = 0 */
float     *x_data;	/* IN: x values of the data points */
float     *y_data;	/* IN: y values of the data points */
float      *y_off;	/* IN: y offset of the data */
int    *nrdata;	/* IN: number of data points */

{	
PCDATA(*stype,*ltype,*binmod,x_data,y_data,*y_off,*nrdata);
return 0;
}

#define PTHIST	pthist_
ROUTINE PTHIST(nbins,cl,rfr,fopt)
int    *nbins;	/* IN: number of bins */ 
float  *cl;	/* IN: values along the x axis */
float  *rfr;	/* IN: number of data points in bin */
float  *fopt;	/* IN: [1] hist. sel; [2] interl. space; [3] angle */

{	
PCHIST(*nbins,cl,rfr,fopt);
return 0;
}

/*==========================================================================*/
 
/***  PTTEXT(text,xc,yc,angle,chsiz,ipos) ***/

#define PPP4	ppp4_
ROUTINE PPP4(xc,yc,angle,chsiz,ipos)
float    *xc;	 /* IN: string position in x */
float    *yc;	 /* IN: string position in y */
float    *angle; /* IN: text angle, in degrees */
float    *chsiz; /* IN: text expansion factor */
int      *ipos;	 /* IN: centering expansion factor (0, 1, 2) */

{	
ptr1 = strp_pntr(1);         /* get stripped string of "text" */

PCTEXT(ptr1,*xc,*yc,*angle,*chsiz,*ipos);
return 0;
}











