#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.IDENTifier     ptk.fc
.AUTHOR         Rein H. Warmels, ESO-IPG
.KEYWORDS       High level graphics interface, Graphics keywords
.LANGUAGE       C
.PURPOSE        Fortran to C interface for PCK
.COMMENTS       Module contains interfaces for the keyword routines
.ENVIRONMENT    MIDAS FORTRAN and C standards
.VERSION        1.0 13-Oct-1993 RHW

 090611		last modif
-----------------------------------------------------------------------------*/

#include <proto_plt.h>
#include <stdlib.h>

int  mm;

char *ptr1, *ptr2;
char *loc_pntr();
char *strp_pntr();

/*

*/

/*==========================================================================*/

/*** idst = PTKRDC(cpar,maxvals,actvals,cval) ***/

#define PPP6	ppp6_
ROUTINE PPP6(maxvals,actvals)
int	*maxvals;	/* IN : no. of elements to get */
int	*actvals;	/* OUT: actual no. of elements returned */

{
int  n;


ptr1 = strp_pntr(1);         /* get stripped string of "cpar" */
ptr2 = loc_pntr(1,&mm);      /* get location of "cval" */

PCKRDC(ptr1,*maxvals,actvals,ptr2);

n = *actvals;
if ((n > 0) && (n < mm)) *(ptr2+n) = ' ';

return 0;
}
 
/*==========================================================================*/

/*** idst = PTKRDI(ipar,maxvals,actvals,ival) ***/

#define PPP7	ppp7_
ROUTINE PPP7(maxvals,actvals,ival)
int  *maxvals;	/* IN : no. of elements to get  */
int  *actvals;	/* OUT: actual no. of elements returned */
int  *ival;	/* OUT: values for the parameters */

{	
ptr1 = strp_pntr(1);         /* get stripped string of "ipar" */

PCKRDI(ptr1,*maxvals,actvals,ival);
return 0;
}

/*==========================================================================*/

/*** idst = PTKRDR(rpar,maxvals,actvals,rval) ***/

#define PPP8	ppp8_
ROUTINE PPP8(maxvals,actvals,rval)
int	*maxvals;	/* IN : no. of elements to get */
int	*actvals;	/* OUT: actual no. of elements returned */
float	   *rval;	/* OUT: values for the parameters */

{	
ptr1 = strp_pntr(1);         /* get stripped string of "ipar" */

PCKRDR(ptr1,*maxvals,actvals,rval);
return 0;
}

/*==========================================================================*/

/*** idst = PTKWRC(cpar,value) ***/

#define PPP9	ppp9_
ROUTINE PPP9(idum)
int  *idum;

{	
ptr1 = strp_pntr(1);         /* get stripped string of "cpar" */
ptr2 = strp_pntr(2);         /* get stripped string of "value" */

PCKWRC(ptr1,ptr2);
return 0;
}

/*==========================================================================*/

/*** idst = PTKWRI(ipar,nrval,ival)  ***/

#define PPP10	ppp10_
ROUTINE PPP10(nrval,ival)
int   *nrval;	/* IN : no. of elements to write  */
int   *ival;	/* IN : values for the parameters */

{	
ptr1 = strp_pntr(1);         /* get stripped string of "ipar" */

PCKWRI(ptr1,*nrval,ival);
return 0;
}

/*==========================================================================*/

/*** idst = PTKWRR(rpar,nrval,rval)  ***/

#define PPP11	ppp11_
ROUTINE PPP11(nrval,rval)
int	  *nrval;	/* IN : no. of elements to write  */
float	   *rval;	/* IN : values for the parameters */

{	
ptr1 = strp_pntr(1);         /* get stripped string of "ipar" */

PCKWRR(ptr1,*nrval,rval);
return 0;
}

#define PTKDEF	ptkdef_
ROUTINE PTKDEF()

{ 
PCKDEF();
return 0;
}






