#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
.VERSION
 090611		last modif

===========================================================================*/
 
#include <stdlib.h>

int  mm;

char *ptr1, *ptr2;
char *loc_pntr();
char *strp_pntr();


#define MAXDIM  3

int  Fillima(), Convcoo(), XConvcoo();

/*
^L
*/

/*
OJO: do not pass single float values, they get passed as double,
     always use pointers
*/

#define YART2	yart2_
ROUTINE YART2(imno,flag,npix,size,retimno,stat)
int  *imno;        /* IN : image id */
int   *flag;	
int   *npix;	
int   *size;
int   *retimno;
int   *stat;

{
ptr1 = strp_pntr(1);         /* get stripped string of "string" */

*stat = Fillima(*flag,*imno,npix,ptr1,size,retimno);
return 0;
}

/*

*/

/*** EXTCOO(imno,string,pixdim,subdim,sublo,subhi,stat) ***/

#define YEXTC1	yextc1_
ROUTINE YEXTC1(imno,pixdim,subdim,sublo,subhi,stat)
int  *imno;        /* IN : image id */
int   *pixdim;	
int   *subdim;
int   *sublo;
int   *subhi;
int   *stat;

{
int   n, mydim, mysubdim, mylo[MAXDIM], myhi[MAXDIM];


ptr1 = strp_pntr(1);         /* get stripped string of "string" */
 
mydim = *pixdim;
*stat = Convcoo(1,*imno,ptr1,mydim,&mysubdim,mylo,myhi);

*subdim = mysubdim;
for (n=0; n<mydim; n++)			/* move to Fortran counting */
   {
   sublo[n] = mylo[n] + 1;
   subhi[n] = myhi[n] + 1;
   }

return 0;
}

/*

*/

#define YEXTC2	yextc2_
ROUTINE YEXTC2(imno,pixdim,subdim,sublo,subhi,stat)
int  *imno;        /* IN : image id */
int   *pixdim;
int   *subdim;
int   *sublo;
float   *subhi;
float   *stat;

{
int   n, mydim, mysubdim;
float  mylo[MAXDIM], myhi[MAXDIM];


ptr1 = strp_pntr(1);         /* get stripped string of "string" */
 
mydim = *pixdim;
*stat = XConvcoo(1,*imno,ptr1,mydim,&mysubdim,mylo,myhi);

*subdim = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */
   {
   sublo[n] = mylo[n] + 1;
   subhi[n] = myhi[n] + 1;
   }

return 0;
}

/*

*/

#define YEXC1	yexc1_
ROUTINE YEXC1(imno,pixdim,subdim,sublo,stat)
int  *imno;        /* IN : image id */
int   *pixdim;
int   *subdim;
int   *sublo;
int   *stat;

{
int   n, mydim, mysubdim, mylo[MAXDIM], myhi[MAXDIM];


ptr1 = strp_pntr(1);         /* get stripped string of "string" */
 
mydim = *pixdim;
*stat = Convcoo(0,*imno,ptr1,mydim,&mysubdim,mylo,myhi);

*subdim = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */
   sublo[n] = mylo[n] + 1;

return 0;
}

/*

*/

#define YEXC2	yexc2_
ROUTINE YEXC2(imno,pixdim,subdim,sublo,stat)
int  *imno;        /* IN : image id */
int   *pixdim;
int   *subdim;
float   *sublo;
float   *stat;

{
int   n, mydim, mysubdim;
float  mylo[MAXDIM], myhi[MAXDIM];


ptr1 = strp_pntr(1);         /* get stripped string of "string" */

mydim = *pixdim;
*stat = XConvcoo(0,*imno,ptr1,mydim,&mysubdim,mylo,myhi);

*subdim = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */
   sublo[n] = mylo[n] + 1;

return 0;
}






