#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/* +++++++++++++++++++++++++  f2cgen.fc  +++++++++++++++++++++++++++++
.LANGUAGE  C
.AUTHOR    K. Banse		ESO - IPG, Garching
.IDENT     Module F2CGEN.FC
.PURPUSE   fortran to C interfaces for general routines
.VERSION   [1.00]  940327

 090611		last modif
------------------------------------------------------------------------*/

#include <midas_def.h>
#include <proto_gen.h> 
#include <stdio.h>
#include <stdlib.h>

int  mm;

char *ptr1, *ptr2;
char *loc_pntr(int, int *);
char *strp_pntr(int);


static int  *pnpixA, *pnpixB, *pbgnA, *pbgnB;
static int   npix[2];
static float xycen[2];
static float *pmag, *pdmag, *psky, *pdsky;
static float *pxsig, *pysig, *pxyval;

#define LUTSIZE 256

/*

*/

#define YY1	yy1_
ROUTINE YY1(npixA,npixB,bgnA,bgnB)
int  *npixA;
int  *npixB;
int  *bgnA;
int  *bgnB;

{
pnpixA = npixA;
pnpixB = npixB;

pbgnA = bgnA;
pbgnB = bgnB;
return 0;
}

#define YY1a	yy1a_
ROUTINE YY1a(nx,ny,xc,yc)
int *nx;
int *ny;
float  *xc;
float  *yc; 

{
npix[0]  = *nx;
npix[1]  = *ny;
xycen[0] = *xc - 1.0;           /* use C indexing for Cjmagn */
xycen[1] = *yc - 1.0;
return 0;
}

#define YY1b	yy1b_
ROUTINE  YY1b(mag,dmag,sky,dsky)
float  *mag;
float  *dmag;
float  *sky;
float  *dsky;

{
pmag = mag;
pdmag = dmag;
psky = sky;
pdsky = dsky;
return 0;
}

#define YY1c	yy1c_
ROUTINE YY1c(xsig,ysig,xyval)
float  *xsig;
float  *ysig;
float  *xyval;

{
pxsig = xsig;
pysig = ysig;
pxyval = xyval;
return 0;
}

#define YY2	yy2_
ROUTINE YY2(pntrA,pntrB,endA)
float   *pntrA;
float   *pntrB;
int  *endA;
{
Ccopwnd(pntrA,pnpixA,pntrB,pnpixB,pbgnA,pbgnB,endA );
return 0;
}

#define YY3	yy3_
ROUTINE YY3(pntrA,dimwA,pntrB)
float   *pntrA;
int  *dimwA;
float   *pntrB;
{
Ccopyf1(pntrA,pnpixA,pbgnA,dimwA,pntrB,pnpixB,pbgnB);
return 0;
}

#define YY4	yy4_
ROUTINE YY4(arr,fac,nrpix,flux,stat)
float  *arr; 
float  *fac;
float  *nrpix;
float  *flux;
int *stat;

	/* jmeth -> pnpixA, ni -> pnpixB, nb -> pbgnA  */

{
*stat = Cjmagn(*pnpixA,arr,npix,*pnpixB,*pbgnA,fac,xycen,
               pmag,pdmag,psky,pdsky,nrpix,flux);
return 0;
}

#define YY5	yy5_
ROUTINE YY5(p_img,image,stat)
float  *p_img;
int *image;
int *stat;

{
int   imap[4];
float xypos[2], xyerr[2], xysig[2];

imap[0] = image[0] - 1;
imap[1] = image[1] - 1;
imap[2] = image[2] - 1;
imap[3] = image[3] - 1;


ptr1 = strp_pntr(1);         /* get stripped string of "meth" */

*stat = Cstacen(ptr1,p_img,npix,imap,xypos,xyerr,xysig,pxyval);

*pmag = xypos[0] + 1;
*pdmag = xypos[1] + 1;
*psky = xyerr[0];
*pdsky = xyerr[1];
*pxsig = xysig[0];
*pysig = xysig[1];
return 0;
}

#define YY6	yy6_
ROUTINE YY6(step,xindx,yindx,limit,nindx)
float  *step;
int *limit;
float  *xindx;
float  *yindx;
int *nindx;
{
double dstep = *step;
*nindx = Cpixlin(*pmag,*pdmag,*psky,*pdsky,dstep,*limit,xindx,yindx);
return 0;
}

#define YY7	yy7_
ROUTINE YY7(p_in,npix,ndim,p_out)
float  *p_in;
int *npix;
int *ndim;
float  *p_out;
{
Czima(p_in,npix,pmag,pdmag,*ndim,p_out,psky,pdsky);
return 0;
}

#define YY8	yy8_
ROUTINE YY8(infile,a,b,fmin,fmax)
float     *a;
int    *b;
float     *fmin;
float     *fmax;

{
void  ReadASCI();


ptr1 = strp_pntr(1);         /* get stripped string of "infile" */

ReadASCI(ptr1,*pnpixA,*pnpixB,a,b,*pbgnA,fmin,fmax);
return 0;
}

#define YY9	yy9_
ROUTINE YY9(idum)
int  *idum;

{
ptr1 = strp_pntr(1);         /* get stripped string of "frame" */

FRAMOU_C(ptr1);
return 0;
}

#define YY10	yy10_
ROUTINE YY10( tid, ncols, nrows, stat )
int    *tid;
int    *ncols;
int    *nrows;
int    *stat;

{
ptr1 = strp_pntr(1);         /* get stripped string of "table" */

OPNTBL(ptr1,tid,ncols,nrows);
*stat = 0;

return 0;
}

static void worky(mlut,qlut)
float *mlut, *qlut;
{
register int jin, jout, jouta, joutb;

jout = 0;
jouta = LUTSIZE;
joutb = LUTSIZE + LUTSIZE;

for (jin=0; jin<3*LUTSIZE; jin+=3)
   {
   mlut[jout++] = qlut[jin];
   mlut[jouta++] = qlut[jin+1];
   mlut[joutb++] = qlut[jin+2];
   }
return;
}

#define YY11	yy11_
ROUTINE YY11(rlut,stat)
float     *rlut;
int    *stat;

{
float mylut[3*LUTSIZE];
int range[2];

*stat = 0;
worky(mylut,rlut);              /* no index massaging of MACRO stuff...!  */

range[0] = 0;
range[1] = 1;

ptr1 = strp_pntr(1);         /* get stripped string of "table" */

CRELUT(ptr1,mylut,LUTSIZE,0,range);

return 0;
}

#define YY12	yy12_
ROUTINE YY12(ritt, stat )
float     *ritt;
int    *stat;

{
*stat = 0;
ptr1 = strp_pntr(1);         /* get stripped string of "table" */

CREITT( ptr1, ritt );
return 0;
}

#define YY13	yy13_
ROUTINE YY13(colno,stat)
int    *colno;
int    *stat;

{
int tcol2ima();


ptr1 = strp_pntr(1);         /* get stripped string of "table" */
ptr2 = strp_pntr(2);         /* get stripped string of "column" */


*stat = tcol2ima(ptr1,ptr2,*colno);
return 0;
return 0;
}

#define YY14	yy14_
ROUTINE YY14(flag,iva,rva,dva)
int    *flag;
int    *iva;
float  *rva;
double *dva;

/* convert Fortran format string to C notation (to print single value)
  input formats: Fx.y, Ixx, or Ex.y, Gx.y
  no variable format possible in really standard Fortran...
  Fortran format = ptr1, result string = ptr2    */


{
char  myform[24], myline[72];

int  lp, mm;



ptr1 = strp_pntr(1);		/* get stripped string of format string */
ptr2 = loc_pntr(1,&mm);		/* get location of output string */

myform[0] = '%';

lp = (int)strlen(ptr1);
if (lp > 22)
   {
   (void) printf("format string > 22, too long ...\n");
   return -1;
   }
 
if (*flag == 2)
   {
   (void) strcpy(myform+1,ptr1+1);
   (void) strcat(myform,"f");
   (void) sprintf(myline,myform,*rva);
   } 
else if (*flag == 3)
   {
   (void) strcpy(myform+1,ptr1+1);
   (void) strcat(myform,"e");
   (void) sprintf(myline,myform,*dva);
   } 
else
   {
   (void) strcpy(myform+1,"d");
   (void) sprintf(myline,myform,*iva);
   } 

myline[mm-1] = '\0';		/* avoid buffer overrun */
(void) strcpy(ptr2,myline);

/* printf("format: %s to: %s\n",ptr1,myform); */

return 0;
}



