#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/* =======================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
 	Internet e-mail: midas@eso.org
 	Postal address: European Southern Observatory
 			Data Management Division 
 			Karl-Schwarzschild-Strasse 2
 			D 85748 Garching bei Muenchen 
 			GERMANY

.VERSION
 090611		last modif

 ======================================================================== */
 
 
#include <midas_def.h>
#include <proto_gen.h>

#include <stdlib.h>

int  mm;

char *ptr1, *ptr2;
char *loc_pntr();
char *strp_pntr();

int  OpFrameCons(), OpFrameFrame(), Func1Frame(), Func2Frame(), 
     Func2FrameCon(), DOpFrameCons(), DOpFrameFrame(), DFunc1Frame(),
     DFunc2Frame(), DFunc2FrameCon();

/* OJO: do not pass single float values, they get passed as double,
        always use pointers */

/*

*/

/* ===========================================================================*/

/*** OPFC(opcode,a,rconst,c,ndim,usrnul,ncount) ***/

#define YOPFC	yopfc_
ROUTINE YOPFC(a,rconst,c,ndim,usrnul,ncount)
float     *a;
float     *rconst;
float     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "opcode" */

*ncount = OpFrameCons(ptr1,a,rconst,c,*ndim,usrnul);

return 0;
}

/* ===========================================================================*/

/*** OPFF(OPCODE,A,B,C,NDIM,USRNUL,NCOUNT) ***/

#define YOPFF	yopff_
ROUTINE YOPFF(a,b,c,ndim,usrnul,ncount)
float     *a;
float     *b;
float     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "opcode" */

*ncount = OpFrameFrame(ptr1,a,b,c,*ndim,usrnul);

return 0;
}


/* ===========================================================================*/

/*** FUN1F(cfunc,a,c,ndim,usrnul,ncount) ***/

#define YFUN1F	yfun1f_
ROUTINE YFUN1F(a,c,ndim,usrnul,ncount)
float     *a;
float     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = Func1Frame(ptr1,a,c,*ndim,usrnul);

return 0;
}

#define YF2FF	yf2ff_
ROUTINE YF2FF(a,b,c,ndim,usrnul,ncount)
float     *a;
float     *b;
float     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = Func2Frame(ptr1,a,b,c,*ndim,usrnul);

return 0;
}

#define YF2FC	yf2fc_
ROUTINE YF2FC(a,scalr,c,ndim,usrnul,ncount)
float     *a;
float     *scalr;
float     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = Func2FrameCon(ptr1,a,scalr,c,*ndim,usrnul);

return 0;
}
/*

*/

#define YDOPFC	ydopfc_
ROUTINE YDOPFC(a,scalr,c,ndim,usrnul,ncount)

double     *a;
double     *scalr;
double     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = DOpFrameCons(ptr1,a,scalr,c,*ndim,usrnul);

return 0;
}

#define YDOPFF	ydopff_
ROUTINE YDOPFF(a,b,c,ndim,usrnul,ncount)
double     *a;
double     *b;
double     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = DOpFrameFrame(ptr1,a,b,c,*ndim,usrnul);

return 0;
}
/*

*/

#define YDF1F	ydf1f_
ROUTINE YDF1F(a,c,ndim,usrnul,ncount)
double     *a;
double     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = DFunc1Frame(ptr1,a,c,*ndim,usrnul);

return 0;
}

#define YDF2FF	ydf2ff_
ROUTINE YDF2FF(a,b,c,ndim,usrnul,ncount)

double     *a;
double     *b;
double     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = DFunc2Frame(ptr1,a,b,c,*ndim,usrnul);

return 0;
}

#define YDF2FC	ydf2fc_
ROUTINE YDF2FC(a,scalr,c,ndim,usrnul,ncount)
double     *a;
double     *scalr;
double     *c;
int  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
int    *ncount;

{
ptr1 = strp_pntr(1);         /* get stripped string of "cfunc" */

*ncount = DFunc2FrameCon(ptr1,a,scalr,c,*ndim,usrnul);

return 0;
}


