#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*+++++++++++++++++++++++++  getinp.fc  +++++++++++++++++++++++++++++++++++++
.MODULE         getinp.fc
.AUTHOR         Rein H. Warmels, ESO-IPG
.KEYWORDS       High level input interface
.LANGUAGE       C
.PURPOSE        Fortran to C interface for USRINP
.COMMENTS       Module contains interfaces for USRINP
.ENVIRONMENT    MIDAS FORTRAN and C standards
.VERSION        1.0 25-Jul-1994 RHW

 090611		last modif
-----------------------------------------------------------------------------*/

#include <midas_def.h>
#include <proto_plt.h>
	
int   mm;
char *ptr1, *ptr2, *ptr3;
char *loc_pntr(int, int *);
char *strp_pntr(int);

/*

*/

/*** stat = USRINP( ctype,cstring,maxval,cbuff,actval) ***/

#define PLSUB1	plsub1_
ROUTINE PLSUB1(maxval,actval,status)
int    *maxval;	/* IN:  maximum number of elements in output array */
int    *actval;	/* OUT: actual number of values found */
int    *status;	/* OUT: status return */

{	
int  n;


ptr1 = strp_pntr(1);            /* get stripped string of "ctype" */
ptr2 = strp_pntr(2);            /* get stripped string of "cstring" */
ptr3 = loc_pntr(1,&mm);         /* get location of "cbuff" */

/* ojo: cbuff serves as buffer for numerical data... */

*status = USRINP(*ptr1,ptr2,*maxval,ptr3,actval);	/* ctype is single char */

n = (int) strlen(ptr1);
if ((n > 0) && (n < mm)) *(ptr1+n) = ' ';

return 0;
}

