
/*

.VERSION
 090723		last modif


*/

extern int  SCTPUT();
extern void nr_error(),free_ivector();


#include <math.h>

#define SWAP(a,b) {float temp=(a);(a)=(b);(b)=temp;}

float fabs_f(x)
float x;
{
  if (x<0) return(-x);
  return(x);
}


int fgaussj(a,n,b,m)
float **a,**b;
int n,m;
{
  int *indxc,*indxr,*ipiv;
  int i,icol,irow,j,k,l,ll,*ivector();
  float big,dum,pivinv,fabs_f();
  

  irow = icol = 0;

  indxc=ivector(1,n);
  indxr=ivector(1,n);
  ipiv=ivector(1,n);
  for (j=1;j<=n;j++) ipiv[j]=0;
  for (i=1;i<=n;i++) {
    big=0.0;
    for (j=1;j<=n;j++)
      if (ipiv[j] != 1)
	for (k=1;k<=n;k++) {
	  if (ipiv[k] == 0) {
	    if (fabs_f(a[j][k]) >= big) {
	      big=fabs_f(a[j][k]);
	      irow=j;
	      icol=k;
	    }
	  } else if (ipiv[k] > 1){
	    nr_error("GAUSSJ: Singular Matrix-1");
	    free_ivector(ipiv,1,n);
	    free_ivector(indxr,1,n);
	    free_ivector(indxc,1,n);
	    return(-1);
	  }
	}
    ++(ipiv[icol]);
    if (irow != icol) {
      for (l=1;l<=n;l++) SWAP(a[irow][l],a[icol][l])
      for (l=1;l<=m;l++) SWAP(b[irow][l],b[icol][l])
			   }
    indxr[i]=irow;
    indxc[i]=icol;
    if (a[icol][icol] == 0.0){
      nr_error("GAUSSJ: Singular Matrix-2");
      free_ivector(ipiv,1,n);
      free_ivector(indxr,1,n);
      free_ivector(indxc,1,n);
      return(-2);
    }
    pivinv=1.0/a[icol][icol];
    a[icol][icol]=1.0;
    for (l=1;l<=n;l++) a[icol][l] *= pivinv;
    for (l=1;l<=m;l++) b[icol][l] *= pivinv;
    for (ll=1;ll<=n;ll++)
      if (ll != icol) {
	dum=a[ll][icol];
	a[ll][icol]=0.0;
	for (l=1;l<=n;l++) a[ll][l] -= a[icol][l]*dum;
	for (l=1;l<=m;l++) b[ll][l] -= b[icol][l]*dum;
      }
  }
  for (l=n;l>=1;l--) {
    if (indxr[l] != indxc[l])
      for (k=1;k<=n;k++)
	SWAP(a[k][indxr[l]],a[k][indxc[l]]);
  }
  free_ivector(ipiv,1,n);
  free_ivector(indxr,1,n);
  free_ivector(indxc,1,n);

  return(0);
}


int dgaussj(a,n,b,m)
double **a,**b;
int n,m;
{
  int *indxc,*indxr,*ipiv;
  int i,icol,irow,j,k,l,ll,*ivector();
  double big,dum,pivinv;
  double fabs();

  irow = icol = 0;

  indxc=ivector(1,n);
  indxr=ivector(1,n);
  ipiv=ivector(1,n);
  for (j=1;j<=n;j++) ipiv[j]=0;
  for (i=1;i<=n;i++) {
    big=0.0;
    for (j=1;j<=n;j++){
      if (ipiv[j] != 1)
	for (k=1;k<=n;k++) {
	  if (ipiv[k] == 0) {
	    if (fabs(a[j][k]) >= big) {
	      big=fabs(a[j][k]);
	      irow=j;
	      icol=k;
	    }
	  } else if (ipiv[k] > 1){
	    nr_error("GAUSSJ: Singular Matrix-1");
	    free_ivector(ipiv,1,n);
	    free_ivector(indxr,1,n);
	    free_ivector(indxc,1,n);
	    return(-1);
	  }
	}
    }
    ++(ipiv[icol]);
    if (irow != icol) {
      for (l=1;l<=n;l++) SWAP(a[irow][l],a[icol][l])
      for (l=1;l<=m;l++) SWAP(b[irow][l],b[icol][l])
			   }
    indxr[i]=irow;
    indxc[i]=icol;
    if (a[icol][icol] == 0.0){
      nr_error("GAUSSJ: Singular Matrix-2");
      free_ivector(ipiv,1,n);
      free_ivector(indxr,1,n);
      free_ivector(indxc,1,n);
      return(-2);
    }
    pivinv=1.0/a[icol][icol];
    a[icol][icol]=1.0;
    for (l=1;l<=n;l++) a[icol][l] *= pivinv;
    for (l=1;l<=m;l++) b[icol][l] *= pivinv;
    for (ll=1;ll<=n;ll++)
      if (ll != icol) {
	dum=a[ll][icol];
	a[ll][icol]=0.0;
	for (l=1;l<=n;l++) a[ll][l] -= a[icol][l]*dum;
	for (l=1;l<=m;l++) b[ll][l] -= b[icol][l]*dum;
      }
  }
  for (l=n;l>=1;l--) {
    if (indxr[l] != indxc[l])
      for (k=1;k<=n;k++)
	SWAP(a[k][indxr[l]],a[k][indxc[l]]);
  }
  free_ivector(ipiv,1,n);
  free_ivector(indxr,1,n);
  free_ivector(indxc,1,n);

  return(0);
}


void nr_error(error_text)
char error_text[];
{
	void exit();

	SCTPUT("ERROR   [gaussj]: Singular matrix -- ABORT !");
}



#undef SWAP
