#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1988-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.TYPE	     Test module
.IDENT       ftoc_commc.c
.LANGUAGE    C
.AUTHOR      Carlos Guirao [ESO/IPG]
.ENVIRONMENT UNIX
.COMMENT     Print in the standard output the Fortran_to_C interface
.REMARKS
.VERSION     1.1   12-Aug-1988: Creation,     CG

 090120		last modif

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <ftoc.h>
#include <ftoc_commc.h>

static int array[5];

/*

*/

#define CSUB	csub_
ROUTINE CSUB(pntr)
long int *pntr;

{
int  *mtr, *xtr;
int  lowmadr;
long int diff;

char  outi[16];



array[0] = 10;
array[1] = 50;
array[2] = 70;
array[3] = array[4] = -1;

/*
printf("vmr.adr (MADRID(1)) = %d\n",vmr.addr);
printf("&array = %x, &vmr.addr = %x\n",array,&vmr.addr);
*/

mtr = (int *)&((&(vmr.addr))[-1]);
xtr = array;

lowmadr = (int) IS_HIGH(array);
if (lowmadr == 1)
   (void) strcpy(outi,"xtr > mtr");
else
   (void) strcpy(outi,"mtr > xtr");

/*
printf("%s : xtr = %x, mtr = %x (hex) or %d, %d (int)\n",outi,xtr,mtr,xtr,mtr);
printf("COMMON_INDEXA = %d, COMMON_INDEXB = %d\n",
       COMMON_INDEXA(array),COMMON_INDEXB(array));
*/

diff = (long int) COMMON_INDEX(array);
if (lowmadr == 1)
   *pntr = diff;
else
   *pntr = -diff;

vmr.addr = 12345;
/*
printf("now, vmr.adr = %d, *pntr = %ld\n",vmr.addr,*pntr);
printf("array[0,1,2] = %d, %d, %d\n\n",array[0],array[1],array[2]);
*/

return(0);
}

#define FIN	fin_
ROUTINE FIN(stat)
int *stat;
{


if (*stat != 0) 
   {
   printf("status = %d\n",*stat);
   exit(*stat);
   }
else
   {
   printf("ftoc_commc.h\n");
   exit(0);
   }
}

#define FMAP	fmap_
ROUTINE FMAP(size,pntr,status)
int *size;		/* IN : number of data values (pixels) to be mapped */
long int *pntr;		/* OUT: pointer to data in memory */
int *status;

{
char *mypntr;
char  outi[16];

int  *mtr, *xtr;
int  lowmadr;
int  map();

long int  diff;

float *fptr;



*status = map(*size,&mypntr);
/*
printf("map returned mypntr = %x\n",mypntr);
*/

mtr = (int *)(&(vmr.addr));
xtr = (int *) mypntr;

lowmadr = (int) IS_HIGH(mypntr);
if (lowmadr == 1)
   (void) strcpy(outi,"xtr > mtr");
else
   (void) strcpy(outi,"mtr > xtr");

/*
printf("%s : xtr = %x, mtr = %x (hex) or %d, %d (int)\n",outi,xtr,mtr,xtr,mtr);
printf("COMMON_INDEXA = %d, COMMON_INDEXB = %d\n",
       COMMON_INDEXA(mypntr),COMMON_INDEXB(mypntr));
*/

diff = (long int) COMMON_INDEX(mypntr);

if (lowmadr == 1)
   *pntr = diff;
else
   *pntr = -diff;

fptr = (float *)mypntr;
*fptr = 77.7;

/*
printf("now, 1st element of allocated array = %f, *pntr = %ld\n",*fptr,*pntr);
*/

return(0);
}


