#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2009 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++
.IDENTIFICATION ftoc_generic.fc
.LANGUAGE       C
.AUTHOR         K. Banse - ESO Garching
.ENVIRONMENT    Any
.KEYWORDS       Fortran to C interface
.COMMENTS       this subroutine is called from for_generic.for
.VERSION  1.0   060315

 090330		last modif
---------------*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


static char  Strip1[256], Strip2[256];

static char  *str_loc1;
static char  *str_loc2;
static int   lenloc1, lenloc2;

static char  *str_strip1 = Strip1;
static char  *str_strip2 = Strip2;

extern struct { int addr[3]; } vmr ;

/*

*/

/*==========================================================================
 *     Check Fortran to C Interface 
 *     FORTRAN calls of CSUB(), SSN(int), SSS(str)
 *==========================================================================*/

#define CSUB	csub_
ROUTINE CSUB()

{
int  m1, m2, mm[3];

char  c, *cpntr;

int  i, *ipntr;
long int  k, *kpntr;

float  r, *rpntr;
double  d, *dpntr;



m1 = sizeof(c), m2 = sizeof(cpntr);
printf("size of char = %d, size of char pntr = %d\n",m1,m2);
m1 = sizeof(i), m2 = sizeof(ipntr);
printf("size of int = %d, size of int pntr = %d\n",m1,m2);
m1 = sizeof(k), m2 = sizeof(kpntr);
printf("size of long int = %d, size of long int pntr = %d\n",m1,m2);
m1 = sizeof(r), m2 = sizeof(rpntr);
printf("size of float = %d, size of float pntr = %d\n",m1,m2);
m1 = sizeof(d), m2 = sizeof(dpntr);
printf("size of double = %d, size of double pntr = %d\n\n",m1,m2);


mm[0] = vmr.addr[0];
mm[1] = vmr.addr[1];
mm[2] = vmr.addr[2];
printf("C: FORTRAN COMMON VMR = %d, %d, %d\n",mm[0],mm[1],mm[2]);

return 0;
}


/*==========================================================================*/

#define SSN	ssn_
ROUTINE SSN(n1)
int *n1;

{
printf("C: here in SSN, n1 = %d\n",*n1);
return 0;
}

/*==========================================================================*/

#define SSR	ssr_
ROUTINE SSR(r1)
float *r1;

{
printf("C: here in SSR, r1 = %f\n",*r1);
return 0;
}

/*==========================================================================*/

#define SSX	ssx_
ROUTINE SSX(n1,n2,n3,r4,n5,n6,n7)
int *n1, *n2, *n3, *n5, *n6, *n7;
float *r4;

{
printf("C: here in SSX, r4 = %f\nn1,2,3,5,6,7 = %d, %d, %d, %d, %d, %d\n",
       *r4,*n1,*n2,*n3,*n5,*n6,*n7);
return 0;
}

/*==========================================================================*/

#define F2CLOC	f2cloc_
ROUTINE F2CLOC(idx,s1,ls1)
int  *idx;
char *s1;	/* F77 String */
int  ls1;

{
int  len;
 

if (*idx == 1)
   {
   str_loc1 = s1;
   lenloc1 = ls1;
   printf("C: here in F2CLOC, on input s1 = %s\nls1 = %d\n",str_loc1,lenloc1);
   memset((void *)str_loc1,32,lenloc1);		/* blank out char_loc */
   len = 11;
   if (len > ls1) len = ls1; 
   (void) strncpy(str_loc1,"abrakadabra",len);
   }
else 
   {
   str_loc2 = s1;
   lenloc2 = ls1;
   printf("C: here in F2CLOC, on input s1 = %s\nls1 = %d\n",str_loc2,lenloc2);
   memset((void *)str_loc2,32,lenloc2);
   len = 14;
   if (len > ls1) len = ls1; 
   (void) strncpy(str_loc2,"Klaus ist faul",len);
   }

return 0;

}

/*==========================================================================*/

#define F2CSTR	f2cstr_
ROUTINE F2CSTR(idx,s1,ls1)
int  *idx;
char *s1;	/* F77 String */
int  ls1;

{
register char cc;

register int m, ln;


 
printf("C: here in F2CSTR, s1 (1st 30 chars) = %30.30s\nls1 = %d\n",s1,ls1);

ln=ls1;
for (m=ln-1; m>0 ;m--)
   {
   cc = s1[m];
   if (cc != ' ') break;

   ln = m;
   }


if (*idx == 1)
   {
   strncpy(Strip1,s1,ln);
   Strip1[ln] = '\0';
   printf("C: stripped s1 = %s|\n",Strip1);
   }
else 
   {
   strncpy(Strip2,s1,ln);
   Strip2[ln] = '\0';
   printf("C: stripped s1 = %s|\n",Strip2);
   }

return 0;
}

/*==========================================================================*/

#define TTT1	ttt1_
ROUTINE TTT1(jdx)
int  *jdx;

{
int  n;

char *adrptr;



if (*jdx == 1)
   adrptr = str_strip1;
else
   adrptr = str_strip2;


n = (int) strlen(adrptr);
printf("C: in TTT1, string = %s\nwith length = %d\n",adrptr,n);

return 0;
}

/*==========================================================================*/

#define TTT2	ttt2_
ROUTINE TTT2(jdx)
int  *jdx;

{
int  n;

char *adrptr;



if (*jdx == 1)
   {
   adrptr = str_loc1;
   n = lenloc1;
   }
else
   {
   adrptr = str_loc2;
   n = lenloc2;
   }

*(adrptr+n) = '\0';
printf("C: in TTT2, string = %s|\n",adrptr);

return 0;
}


